Index: trunk/tests/NodeHeirarchyTest.php
===================================================================
--- trunk/tests/NodeHeirarchyTest.php	(revision 1)
+++ trunk/tests/NodeHeirarchyTest.php	(revision 1)
@@ -0,0 +1,160 @@
+<?php
+/// FIXME: Tests not implemented.
+return;
+
+/**
+ * PHPUnit test case for NodeHeirarchy
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+require_once 'PHPUnit.php';
+class NodeHeirarchyTest extends PHPUnit_TestCase {
+
+    var $NodeHeirarchy;
+
+    function NodeHeirarchyTest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/NodeHeirarchy.inc.php';
+        $this->NodeHeirarchy =& new NodeHeirarchy(PARAM);
+    }
+
+    function tearDown()
+    {
+        unset($this->NodeHeirarchy);
+    }
+
+    function test_currentnode()
+    {
+        $result = $this->NodeHeirarchy->currentnode(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_tostringid()
+    {
+        $result = $this->NodeHeirarchy->tostringid(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_toarrayid()
+    {
+        $result = $this->NodeHeirarchy->toarrayid(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_insertnode()
+    {
+        $result = $this->NodeHeirarchy->insertnode(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_deletenode()
+    {
+        $result = $this->NodeHeirarchy->deletenode(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_movenode()
+    {
+        $result = $this->NodeHeirarchy->movenode(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getparents()
+    {
+        $result = $this->NodeHeirarchy->getparents(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getnode()
+    {
+        $result = $this->NodeHeirarchy->getnode(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getchildren()
+    {
+        $result = $this->NodeHeirarchy->getchildren(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getnumberchildren()
+    {
+        $result = $this->NodeHeirarchy->getnumberchildren(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_isleaf()
+    {
+        $result = $this->NodeHeirarchy->isleaf(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_isancestor()
+    {
+        $result = $this->NodeHeirarchy->isancestor(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getallancestors()
+    {
+        $result = $this->NodeHeirarchy->getallancestors(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_nodeexists()
+    {
+        $result = $this->NodeHeirarchy->nodeexists(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_getnodelist()
+    {
+        $result = $this->NodeHeirarchy->getnodelist(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_rebuildsubnodeqty()
+    {
+        $result = $this->NodeHeirarchy->rebuildsubnodeqty(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+    function test_setsubnodeqtytoparents()
+    {
+        $result = $this->NodeHeirarchy->setsubnodeqtytoparents(PARAM);
+        $expected = EXPECTED_VAL;
+        $this->assertEquals($expected, $result);
+    }
+
+}
+// Running the test.
+$suite = new PHPUnit_TestSuite('NodeHeirarchyTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/PEditTest.php
===================================================================
--- trunk/tests/PEditTest.php	(revision 815)
+++ trunk/tests/PEditTest.php	(revision 1)
@@ -4,35 +4,14 @@
 
 /**
- * The Strangecode Codebase - a general application development framework for PHP
- * For details visit the project site: <http://trac.strangecode.com/codebase/>
- * Copyright 2001-2012 Strangecode, LLC
+ * PHPUnit test case for PEdit
  * 
- * This file is part of The Strangecode Codebase.
- *
- * The Strangecode Codebase is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as published by the
- * Free Software Foundation, either version 3 of the License, or (at your option)
- * any later version.
+ * T\he method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
  * 
- * The Strangecode Codebase is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
- * details.
- * 
- * You should have received a copy of the GNU General Public License along with
- * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
- */
-
-/**
- * PHPUnit test case for codebase/lib/PEdit.inc.php
- *
- * T\he method skeletons below need to be filled in with
- * real data so that the tests will run correctly. Replace
- * all EXPECTED_VAL and PARAM strings with real data.
- *
  * Created with PHPUnit_Skeleton on 2005-08-09
  */
-
-class PEditTest extends PHPUnit_Framework_TestCase {
+require_once 'PHPUnit.php';
+class PEditTest extends PHPUnit_TestCase {
 
     var $PEdit;
@@ -40,5 +19,5 @@
     function PEditTest($name)
     {
-        $this->PHPUnit_Framework_TestCase($name);
+        $this->PHPUnit_TestCase($name);
     }
 
@@ -154,2 +133,7 @@
 
 }
+// Running the test.
+$suite = new PHPUnit_TestSuite('PEditTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/PageNumbersTest.php
===================================================================
--- trunk/tests/PageNumbersTest.php	(revision 815)
+++ trunk/tests/PageNumbersTest.php	(revision 1)
@@ -4,35 +4,14 @@
 
 /**
- * The Strangecode Codebase - a general application development framework for PHP
- * For details visit the project site: <http://trac.strangecode.com/codebase/>
- * Copyright 2001-2012 Strangecode, LLC
+ * PHPUnit test case for PageNumbers
  * 
- * This file is part of The Strangecode Codebase.
- *
- * The Strangecode Codebase is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as published by the
- * Free Software Foundation, either version 3 of the License, or (at your option)
- * any later version.
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
  * 
- * The Strangecode Codebase is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
- * details.
- * 
- * You should have received a copy of the GNU General Public License along with
- * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
- */
-
-/**
- * PHPUnit test case for codebase/lib/PageNumbers.inc.php
- *
- * The method skeletons below need to be filled in with
- * real data so that the tests will run correctly. Replace
- * all EXPECTED_VAL and PARAM strings with real data.
- *
  * Created with PHPUnit_Skeleton on 2005-08-09
  */
-
-class PageNumbersTest extends PHPUnit_Framework_TestCase {
+require_once 'PHPUnit.php';
+class PageNumbersTest extends PHPUnit_TestCase {
 
     var $PageNumbers;
@@ -40,5 +19,5 @@
     function PageNumbersTest($name)
     {
-        $this->PHPUnit_Framework_TestCase($name);
+        $this->PHPUnit_TestCase($name);
     }
 
@@ -133,2 +112,7 @@
 
 }
+// Running the test.
+$suite = new PHPUnit_TestSuite('PageNumbersTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/PageSequenceTest.php
===================================================================
--- trunk/tests/PageSequenceTest.php	(revision 815)
+++ trunk/tests/PageSequenceTest.php	(revision 1)
@@ -4,35 +4,14 @@
 
 /**
- * The Strangecode Codebase - a general application development framework for PHP
- * For details visit the project site: <http://trac.strangecode.com/codebase/>
- * Copyright 2001-2012 Strangecode, LLC
+ * PHPUnit test case for PageSequence
  * 
- * This file is part of The Strangecode Codebase.
- *
- * The Strangecode Codebase is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as published by the
- * Free Software Foundation, either version 3 of the License, or (at your option)
- * any later version.
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
  * 
- * The Strangecode Codebase is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
- * details.
- * 
- * You should have received a copy of the GNU General Public License along with
- * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
- */
-
-/**
- * PHPUnit test case for codebase/lib/PageSequence.inc.php
- *
- * The method skeletons below need to be filled in with
- * real data so that the tests will run correctly. Replace
- * all EXPECTED_VAL and PARAM strings with real data.
- *
  * Created with PHPUnit_Skeleton on 2005-08-09
  */
-
-class PageSequenceTest extends PHPUnit_Framework_TestCase {
+require_once 'PHPUnit.php';
+class PageSequenceTest extends PHPUnit_TestCase {
 
     var $PageSequence;
@@ -40,5 +19,5 @@
     function PageSequenceTest($name)
     {
-        $this->PHPUnit_Framework_TestCase($name);
+        $this->PHPUnit_TestCase($name);
     }
 
@@ -182,2 +161,7 @@
 
 }
+// Running the test.
+$suite = new PHPUnit_TestSuite('PageSequenceTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/PayPalTest.php
===================================================================
--- trunk/tests/PayPalTest.php	(revision 815)
+++ trunk/tests/PayPalTest.php	(revision 1)
@@ -1,37 +1,21 @@
 <?php
 /**
- * The Strangecode Codebase - a general application development framework for PHP
- * For details visit the project site: <http://trac.strangecode.com/codebase/>
- * Copyright 2001-2012 Strangecode, LLC
+ * PHPUnit test case for PayPal
  * 
- * This file is part of The Strangecode Codebase.
- *
- * The Strangecode Codebase is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as published by the
- * Free Software Foundation, either version 3 of the License, or (at your option)
- * any later version.
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
  * 
- * The Strangecode Codebase is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
- * details.
- * 
- * You should have received a copy of the GNU General Public License along with
- * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
- */
-
-/**
- * PHPUnit test case for codebase/lib/PayPal.inc.php
- *
- * The method skeletons below need to be filled in with
- * real data so that the tests will run correctly. Replace
- * all EXPECTED_VAL and PARAM strings with real data.
- *
  * Created with PHPUnit_Skeleton on 2005-08-09
  */
-
-class PayPalTest extends PHPUnit_Framework_TestCase {
+require_once 'PHPUnit.php';
+class PayPalTest extends PHPUnit_TestCase {
 
     var $PayPal;
+
+    function PayPalTest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
 
     function setUp()
@@ -39,5 +23,5 @@
         require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/PayPal.inc.php';
-        $this->PayPal = new PayPal();
+        $this->PayPal =& new PayPal();
 
         // Defaults for purchasing classified postings.
@@ -85,6 +69,5 @@
         ));
         $result = $this->PayPal->getlink('testitem');
-        //$this->assertTrue(preg_match('/customdata/', $result));
-        $this->assertSame(1, preg_match('/customdata/', $result));
+        $this->assertTrue(preg_match('/customdata/', $result));
     }
 
@@ -99,7 +82,5 @@
         $this->PayPal->printbutton('testitem');
         $result = ob_get_clean();
-        //$this->assertTrue(preg_match('/customdata/', $result));
-        $this->assertSame(1, preg_match('/customdata/', $result));
-        
+        $this->assertTrue(preg_match('/customdata/', $result));
     }
 
@@ -120,10 +101,10 @@
 //         $result = $this->PayPal->incomingipnrequest();
 //     }
-//
+// 
 //     function test_processipn()
 //     {
 //         $result = $this->PayPal->processipn();
 //     }
-//
+// 
 //     function test_verifiedipn()
 //     {
@@ -132,2 +113,7 @@
 
 }
+// Running the test.
+$suite = new PHPUnit_TestSuite('PayPalTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/PrefsTest.php
===================================================================
--- trunk/tests/PrefsTest.php	(revision 815)
+++ trunk/tests/PrefsTest.php	(revision 1)
@@ -4,35 +4,14 @@
 
 /**
- * The Strangecode Codebase - a general application development framework for PHP
- * For details visit the project site: <http://trac.strangecode.com/codebase/>
- * Copyright 2001-2012 Strangecode, LLC
- *
- * This file is part of The Strangecode Codebase.
- *
- * The Strangecode Codebase is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as published by the
- * Free Software Foundation, either version 3 of the License, or (at your option)
- * any later version.
- *
- * The Strangecode Codebase is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
- * details.
- *
- * You should have received a copy of the GNU General Public License along with
- * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
- */
-
-/**
- * PHPUnit test case for codebase/lib/Prefs.inc.php
- *
- * The method skeletons below need to be filled in with
- * real data so that the tests will run correctly. Replace
- * all EXPECTED_VAL and PARAM strings with real data.
- *
+ * PHPUnit test case for Prefs
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
  * Created with PHPUnit_Skeleton on 2005-08-09
  */
-
-class PrefsTest extends PHPUnit_Framework_TestCase {
+require_once 'PHPUnit.php';
+class PrefsTest extends PHPUnit_TestCase {
 
     var $Prefs;
@@ -40,5 +19,5 @@
     function PrefsTest($name)
     {
-        $this->PHPUnit_Framework_TestCase($name);
+        $this->PHPUnit_TestCase($name);
     }
 
@@ -47,7 +26,5 @@
         require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/Prefs.inc.php';
-        $prefs = new Prefs('test', array(
-            'storagetype' => 'session',
-        ));
+        $this->Prefs =& new Prefs(PARAM);
     }
 
@@ -71,7 +48,7 @@
     }
 
-    function test_getue()
+    function test_getvalue()
     {
-        $result = $this->Prefs->getue(PARAM);
+        $result = $this->Prefs->getvalue(PARAM);
         $expected = EXPECTED_VAL;
         $this->assertEquals($expected, $result);
@@ -114,2 +91,7 @@
 
 }
+// Running the test.
+$suite = new PHPUnit_TestSuite('PrefsTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/RecordLockTest.php
===================================================================
--- trunk/tests/RecordLockTest.php	(revision 1)
+++ trunk/tests/RecordLockTest.php	(revision 1)
@@ -0,0 +1,192 @@
+<?php
+/**
+ * PHPUnit test case for RecordLock
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+require_once 'PHPUnit.php';
+class RecordLockTest extends PHPUnit_TestCase {
+
+    var $RecordLock;
+    var $Auth_SQL;
+
+    function RecordLockTest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/RecordLock.inc.php';
+        require_once '../lib/Auth_SQL.inc.php';
+
+        $this->Auth_SQL =& new Auth_SQL('testauth');
+        $this->Auth_SQL->setParam(array(
+            'db_table'          => 'test_user_tbl',
+            'db_primary_key'    => 'user_id',
+            'db_login_table'    => 'test_login_tbl',
+            'login_url'         => '/login.php',
+            'blocking'          => true
+        ));
+
+        // Use fresh user table.
+        $this->Auth_SQL->initDB(true);
+
+        // Insert test data.
+        DB::query("
+            INSERT INTO test_user_tbl (
+                username,
+                userpass,
+                first_name,
+                last_name,
+                email,
+                user_type
+            ) VALUES (
+                'testuser',
+                md5('testpass'),
+                'John',
+                'Doe',
+                'john@example.com',
+                'admin'
+            )
+        ");
+        $this->Auth_SQL->login('testuser', 'testpass');
+
+        $this->RecordLock =& RecordLock::getInstance($this->Auth_SQL);
+        $this->RecordLock->setParam(array('db_table' => 'test_lock_tbl'));
+
+        // Use fresh lock table.
+        $this->RecordLock->initDB(true);
+    }
+
+    function tearDown()
+    {
+        unset($this->RecordLock);
+        unset($this->Auth_SQL);
+        DB::query("DROP TABLE IF EXISTS test_user_tbl");
+        DB::query("DROP TABLE IF EXISTS test_login_tbl");
+        DB::query("DROP TABLE IF EXISTS test_lock_tbl");
+    }
+
+    function test_getinstance()
+    {
+        $result = RecordLock::getinstance($this->Auth_SQL);
+        $this->assertTrue($result && is_a($result, 'RecordLock'));
+    }
+
+    function test_setparam()
+    {
+        $this->RecordLock->setparam(array('var'=>'val'));
+    }
+
+    function test_getparam()
+    {
+        $this->RecordLock->getparam('var');
+    }
+
+    function test_select()
+    {
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->assertTrue($result);
+    }
+
+    function test_islocked()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->islocked();
+        $this->assertTrue($result, 'Lock was not set.');
+
+        $this->RecordLock->remove();
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->islocked();
+        $this->assertFalse($result, 'Lock was not removed.');
+    }
+
+    function test_ismine()
+    {
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->ismine();
+        $this->assertTrue($result);
+    }
+
+    function test_set()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->remove();
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->islocked();
+        $this->assertTrue($result);
+    }
+
+    function test_remove()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->remove();
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->islocked();
+        $this->assertFalse($result);
+    }
+
+    function test_removeall()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->removeall();
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->islocked();
+        $this->assertFalse($result);
+    }
+
+    function test__auto_timeout()
+    {
+        $this->RecordLock->_auto_timeout();
+    }
+
+    function test_getid()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1');
+        $result = $this->RecordLock->getid();
+        $this->assertTrue('' != $result);
+        $this->assertTrue(is_numeric($result));
+    }
+
+    function test_gettitle()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1', 'userlock');
+        $result = $this->RecordLock->gettitle();
+        $this->assertEquals('userlock', $result);
+    }
+
+    function test_geteditor()
+    {
+        $this->RecordLock->select('test_user_tbl', 'user_id', '1');
+        $this->RecordLock->set('test_user_tbl', 'user_id', '1', 'userlock');
+        $result = $this->RecordLock->geteditor();
+        $this->assertEquals('testuser', $result);
+    }
+
+    function test_getsecondselapsed()
+    {
+        $result = $this->RecordLock->getsecondselapsed();
+        $this->assertType('integer', $result);
+    }
+
+}
+// Running the test.
+$suite = new PHPUnit_TestSuite('RecordLockTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
Index: trunk/tests/RecordVersionTest.php
===================================================================
--- trunk/tests/RecordVersionTest.php	(revision 1)
+++ trunk/tests/RecordVersionTest.php	(revision 1)
@@ -0,0 +1,174 @@
+<?php
+/**
+ * PHPUnit test case for RecordVersion
+ * 
+ * The method skeletons below need to be filled in with 
+ * real data so that the tests will run correctly. Replace 
+ * all EXPECTED_VAL and PARAM strings with real data. 
+ * 
+ * Created with PHPUnit_Skeleton on 2005-08-09
+ */
+require_once 'PHPUnit.php';
+class RecordVersionTest extends PHPUnit_TestCase {
+
+    var $RecordVersion;
+    var $Auth_SQL;
+
+    function RecordVersionTest($name)
+    {
+        $this->PHPUnit_TestCase($name);
+    }
+
+    function setUp()
+    {
+        require dirname(__FILE__) . '/_config.inc.php';
+        require_once '../lib/RecordVersion.inc.php';
+
+        require_once '../lib/Auth_SQL.inc.php';
+        $this->Auth_SQL =& new Auth_SQL('testauth');
+        $this->Auth_SQL->setParam(array(
+            'db_table'          => 'test_user_tbl',
+            'db_primary_key'    => 'user_id',
+            'db_login_table'    => 'test_login_tbl',
+            'login_url'         => '/login.php',
+            'blocking'          => true
+        ));
+
+        // Use fresh user table.
+        $this->Auth_SQL->initDB(true);
+        
+        // Insert test data.
+        DB::query("
+            INSERT INTO test_user_tbl (
+                username,
+                userpass,
+                first_name,
+                last_name,
+                email,
+                user_type
+            ) VALUES (
+                'testuser',
+                md5('testpass'),
+                'John',
+                'Doe',
+                'john@example.com',
+                'admin'
+            )
+        ");
+        
+        $this->Auth_SQL->login('testuser', 'testpass');
+        
+        $this->RecordVersion =& RecordVersion::getInstance($this->Auth_SQL);
+        $this->RecordVersion->setParam(array('db_table' => 'test_version_tbl'));
+
+        // Use fresh version table.
+        $this->RecordVersion->initDB(true);
+    }
+
+    function tearDown()
+    {
+        unset($this->RecordVersion);
+        unset($this->Auth_SQL);
+        DB::query("DROP TABLE IF EXISTS test_user_tbl");
+        DB::query("DROP TABLE IF EXISTS test_login_tbl");
+        DB::query("DROP TABLE IF EXISTS test_version_tbl");
+    }
+
+    function test_getinstance()
+    {
+        $result = RecordVersion::getinstance($this->Auth_SQL);
+        $this->assertTrue($result && is_a($result, 'RecordVersion'));
+    }
+
+    function test_setparam()
+    {
+        $this->RecordVersion->setparam(array('var'=>'val'));
+    }
+
+    function test_getparam()
+    {
+        $this->RecordVersion->getparam('var');
+    }
+
+    function test_create()
+    {
+        $result = $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test User', 'First version of user');
+        $this->assertTrue($result);
+    }
+
+    function test_restore()
+    {
+        $current = $this->RecordVersion->getCurrent('test_user_tbl', 'user_id', '1');
+        $version_id = $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test User', 'First version of user');
+        $versioned = $this->RecordVersion->getData($version_id);
+        $result = $this->RecordVersion->restore($version_id);
+        $restored = $this->RecordVersion->getCurrent('test_user_tbl', 'user_id', '1');
+        $this->assertTrue(is_array($result), 'Restore did not return array.');
+        $this->assertTrue($current === $versioned && $versioned === $restored, 'Restored version does not match original.');
+    }
+
+    function test_deleteold()
+    {
+        // Creat 3 test versions.
+        $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test 1', '1 version of user');
+        $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test 2', '2 version of user');
+        $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test 3', '3 version of user');
+
+        $a = $this->RecordVersion->getList('test_user_tbl', 'user_id', '1');
+
+        $this->RecordVersion->deleteold('test_user_tbl', 'user_id', '1');
+        $b = $this->RecordVersion->getList('test_user_tbl', 'user_id', '1');
+
+        $this->RecordVersion->setparam(array('max_qty'=>2));
+        $this->RecordVersion->setparam(array('min_qty'=>1));
+        $this->RecordVersion->setparam(array('min_days'=>0));
+        $this->RecordVersion->deleteold('test_user_tbl', 'user_id', '1');
+        $c = $this->RecordVersion->getList('test_user_tbl', 'user_id', '1');
+
+        $this->RecordVersion->setparam(array('max_qty'=>0));
+        $this->RecordVersion->setparam(array('min_qty'=>0));
+        $this->RecordVersion->setparam(array('min_days'=>0));
+        $this->RecordVersion->deleteold('test_user_tbl', 'user_id', '1');
+        $d = $this->RecordVersion->getList('test_user_tbl', 'user_id', '1');
+
+        $this->assertTrue(sizeof($a) == 3, 'A is wrong');
+        $this->assertTrue(sizeof($b) == 3, 'B is wrong');
+        $this->assertTrue(sizeof($c) == 1, 'C is wrong');
+        $this->assertTrue(sizeof($d) == 0, 'D is wrong');
+    }
+
+    function test_getlist()
+    {
+        $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test 1', '1 version of user');
+        $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test 2', '2 version of user');
+        $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test 3', '3 version of user');
+        $result = $this->RecordVersion->getList('test_user_tbl', 'user_id', '1');
+        $this->assertTrue(is_array($result) && !empty($result));
+    }
+
+    function test_getverson()
+    {
+        $version_id = $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test User', 'First version of user');
+        $result = $this->RecordVersion->getverson($version_id);
+        $this->assertTrue(is_array($result) && !empty($result));
+    }
+
+    function test_getdata()
+    {
+        $version_id = $this->RecordVersion->create('test_user_tbl', 'user_id', '1', 'Test User', 'First version of user');
+        $result = $this->RecordVersion->getdata($version_id);
+        $this->assertTrue(is_array($result) && !empty($result));
+    }
+
+    function test_getcurrent()
+    {
+        $result = $this->RecordVersion->getCurrent('test_user_tbl', 'user_id', '1');
+        $this->assertTrue(is_array($result) && !empty($result));
+    }
+
+}
+// Running the test.
+$suite = new PHPUnit_TestSuite('RecordVersionTest');
+$result = PHPUnit::run($suite);
+echo $result->toString();
+?>
